// TestApp1.cpp : Defines the entry point for the application.
//

#ifdef _WIN32
#include "Win32/stdafx.h"
#endif

#include <DK.h>


class TestApp1 : public DKApplication
{
	DKObject<DKThread> thread;
public:
	void OnInitialize(void) override
	{
		DKLog("---- SystemPath ----");
		DKLog("SystemRoot: %ls", DefaultPath(SystemPath::SystemRoot));
		DKLog("AppRoot: %ls", DefaultPath(SystemPath::AppRoot));
		DKLog("AppResource: %ls", DefaultPath(SystemPath::AppResource));
		DKLog("AppExecutable: %ls", DefaultPath(SystemPath::AppExecutable));
		DKLog("AppData: %ls", DefaultPath(SystemPath::AppData));
		DKLog("UserHome: %ls", DefaultPath(SystemPath::UserHome));
		DKLog("UserDocuments: %ls", DefaultPath(SystemPath::UserDocuments));
		DKLog("UserPreferences: %ls", DefaultPath(SystemPath::UserPreferences));
		DKLog("UserCache: %ls", DefaultPath(SystemPath::UserCache));
		DKLog("UserTemp: %ls", DefaultPath(SystemPath::UserTemp));
		DKLog("---- ProcessInfo ----");
		DKLog("HostName: %ls", ProcessInfoString(ProcessInfo::HostName));
		DKLog("OsName: %ls", ProcessInfoString(ProcessInfo::OsName));
		DKLog("UserName: %ls", ProcessInfoString(ProcessInfo::UserName));
		DKLog("ModulePath: %ls", ProcessInfoString(ProcessInfo::ModulePath));

		thread = DKThread::Create(DKFunction([this]()
		{
			this->EventLoop()->Post(DKFunction([&]()
			{
				DKLog("test1");
			})->Invocation(), 2);
			this->EventLoop()->Post(DKFunction([&]()
			{
				DKLog("test2");
			})->Invocation(), 4);
			this->EventLoop()->Post(DKFunction([&]()
			{
				DKLog("Terminate!!");
				DKApplication::Instance()->Terminate(0);
			})->Invocation(), 6);

		})->Invocation());
	}
	void OnTerminate(void) override
	{
		thread->WaitTerminate();
	}
};


#ifdef _WIN32
int APIENTRY wWinMain(_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPWSTR    lpCmdLine,
	_In_ int       nCmdShow)
#else
int main(int argc, const char * argv[])
#endif
{
	TestApp1 app;
	return app.Run();
}
